//+------------------------------------------------------------------+
//|                                          Pending Order ecnv9.mq4 |
//|                                                                  |
//|                                                  http://www..com |
//+------------------------------------------------------------------+


#property copyright ""
//-----------------------------------------------------------------------------+
// External Variables
extern bool   DynamicLotSize = false;
extern double Multiplier     =   2;
extern double EquityPercent  =   1;
extern double FixedLotSize   = 0.01;
extern double StopLoss       =  90;
extern double TakeProfit     =   2;
extern double TrailingStop   =   0;
extern int    MinimumProfit  =   1;
extern double BreakEven      =   0;
extern double ProfitMin      =   0;
extern int    Slippage       =   5;
extern double ReturnDist     =   2;
extern int    MinStop       =    1;
extern int    MaxOrders      =   7;
extern int    PendingPips    =   2;
extern int    MagicNumber    = 123456;

//-----------------------------------------------------------------------------+
// Global Variables

int    Ticket,total,OpenOpposite=1,UseSlippage,i;
double LotSize,OpenPrice,pt,PendingBuyPrice,PendingSellPrice;
double StopLevel,UpperStopLevel,LowerStopLevel;
double mlots,lastprofit,lastlot;
double BuyStopLoss,BuyTakeProfit,SellStopLoss,SellTakeProfit;
double MaxStopLoss,PipsProfit;
//-----------------------------------------------------------------------------+
int init()
	  {
	   if (Digits ==3 || Digits ==5)pt=10*Point;
      else pt=Point;
      UseSlippage = GetSlippage(Symbol(),Slippage);
      }
//-----------------------------------------------------------------------------+
   int start()
     {
      if (OrdersTotal()==0)GoToOpen();
       else GoToClose();
      if(TrailingStop>0)BuyTrailingStop();
      if(TrailingStop>0)SellTrailingStop();
      if(OpenOpposite>0)OpenOppositeOrder(); 
      if(OrdersTotal()>0)OpPendingDel();
      if(BreakEven>0)MoveBreakEven();
     }
//+---------------------------------------------------------------------------+	
// Get Slippage Function

     int GetSlippage(string Currency, int SlippagePips)
	  {
		int CalcDigits = MarketInfo(Currency,MODE_DIGITS);
		if(CalcDigits == 2 || CalcDigits == 4) double CalcSlippage = SlippagePips;
		else if(CalcDigits == 3 || CalcDigits == 5) CalcSlippage = SlippagePips*10;
		return(CalcSlippage);
	  }	  
//+---------------------------------------------------------------------------+
int GoToOpen()
{         		
// Lot size calculation

        if(DynamicLotSize == true)
        {
         double RiskAmount = AccountEquity() * (EquityPercent / 100);
         double TickValue = MarketInfo(Symbol(),MODE_TICKVALUE);
         if(Point == 0.001 || Point == 0.00001) TickValue *= 10;
         double LotSize = (RiskAmount / StopLoss) / TickValue;
        }
      else LotSize = FixedLotSize;
//+---------------------------------------------------------------------------+     
// Lot size verification

        if(LotSize < MarketInfo(Symbol(),MODE_MINLOT))
        {
         LotSize = MarketInfo(Symbol(),MODE_MINLOT);
        }
     else if(LotSize > MarketInfo(Symbol(),MODE_MAXLOT))
        {
         LotSize = MarketInfo(Symbol(),MODE_MAXLOT);
        }		
         if(MarketInfo(Symbol(),MODE_LOTSTEP) == 0.1)
        {
         LotSize = NormalizeDouble(LotSize,1);
        }
     else LotSize = NormalizeDouble(LotSize,2);
	 	  {
	 	
//+----------------------------------------------------------------------------+		
//Buy Limits Verification
 
    StopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
    RefreshRates();
    UpperStopLevel=Ask+StopLevel; 
    LowerStopLevel=Bid-StopLevel;
    
// Buy Pending Price Calculation

   PendingBuyPrice = Ask+PendingPips*pt;
   if(PendingBuyPrice<UpperStopLevel)PendingBuyPrice=UpperStopLevel+MinStop*pt;
   
// Buy Pending Stop Loss & Take Profit Calculation

   if(StopLoss>0)BuyStopLoss=PendingBuyPrice-(StopLoss*pt);
   if(TakeProfit>0)BuyTakeProfit=PendingBuyPrice+(TakeProfit*pt);
   
//Minimum Stop Loss & Take Profit
      
   if(BuyStopLoss>0 && BuyStopLoss>LowerStopLevel)
    {
     BuyStopLoss=LowerStopLevel-MinStop*pt;
    }
     if(BuyTakeProfit>0 && BuyTakeProfit<UpperStopLevel)
    {
     BuyTakeProfit=UpperStopLevel+MinStop*pt;
    } 
    
//Place Buy Pending Order  
   
         while(IsTradeContextBusy()) Sleep(10);
		       RefreshRates();
         Ticket=OrderSend(Symbol(),OP_BUYSTOP,LotSize,PendingBuyPrice,UseSlippage,BuyStopLoss,BuyTakeProfit,"Buy Stop Order",MagicNumber,0,Green);
         if(Ticket>0)
           {
            if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("BUY Stop Order Opened : ",OrderOpenPrice());
           }
        else Print("Error opening BUY Stop Order : ",GetLastError());
           }
//-----------------------------------------------------------------------------+
//Sell Limits Verification
	
    StopLevel=MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
    RefreshRates();
    UpperStopLevel=Ask+StopLevel;
    LowerStopLevel=Bid-StopLevel; 
        
// Sell Pending Price Calculation
     
   PendingSellPrice= Bid-PendingPips*pt;
   if(PendingSellPrice>LowerStopLevel)PendingSellPrice=LowerStopLevel-MinStop*pt;
        
//  Sell Pending Stop Loss & Take Profit Calculation     
     
   if(StopLoss>0)SellStopLoss=PendingSellPrice+(StopLoss*pt);
   if(TakeProfit>0)SellTakeProfit=PendingSellPrice-(TakeProfit*pt);
   
 //Minimum Stop Loss & Take Profit
   
   if(SellStopLoss>0 && SellStopLoss<UpperStopLevel)
    {
     SellStopLoss=UpperStopLevel+MinStop*pt;
    }
     if(SellTakeProfit>0 && SellTakeProfit>LowerStopLevel)
    {
     SellTakeProfit=LowerStopLevel-MinStop*pt;
    }
    
//Place Buy Pending Order  
        
         while(IsTradeContextBusy()) Sleep(10);
		       RefreshRates();       
         Ticket=OrderSend(Symbol(),OP_SELLSTOP,LotSize,PendingSellPrice,UseSlippage,SellStopLoss,SellTakeProfit,"Sell Stop Order",MagicNumber,0,Red);
         if(Ticket>0)
           {
            if(OrderSelect(Ticket,SELECT_BY_TICKET,MODE_TRADES)) Print("SELL Stop Order Opened : ",OrderOpenPrice());
           }
        else Print("Error opening SELL Stop Order : ",GetLastError());
           } 
//+---------------------------------------------------------------------------+
void OpenOppositeOrder() 
 {
 // LastOrder Loss Compensation 
       
    for(i=0;i<OrdersTotal();i++)
      {
       OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
     if(OrderSymbol()==Symbol()&& OrderMagicNumber()== MagicNumber)
       {
        lastprofit = OrderProfit(); 
        lastlot = OrderLots();
       }
      }
     mlots=0;
     if (lastprofit<0)mlots=NormalizeDouble(lastlot*Multiplier,2);
       else mlots=LotSize;
  
//+------------------------------------------------------------------+ 
//Open Opposite Order
 
   double  MartingaleBuyPrice = Ask+StopLevel;
   if(MartingaleBuyPrice<UpperStopLevel)MartingaleBuyPrice=UpperStopLevel+MinStop*pt;
   
   double MartingaleSellPrice= Bid-StopLevel;
   if(MartingaleSellPrice>LowerStopLevel)MartingaleSellPrice=LowerStopLevel-MinStop*pt;
   
   int Op;  
   
   for(int Counter = OrdersTotal()-1; Counter >= 0; Counter--)
      {
      if(OrderSelect(Counter,SELECT_BY_POS,MODE_TRADES))  
         {
         if(OrderSymbol() == Symbol()&& OrderMagicNumber() == MagicNumber)
            {
            Op = OrderType();

            if(Op == OP_BUY && ((OrderOpenPrice()-OrderClosePrice())/pt)>TakeProfit)
               {                
               Ticket = OrderSend(Symbol(), OP_SELL, mlots, MartingaleSellPrice, UseSlippage, 0, 0, "Sell Order", MagicNumber, 0, Red);
               if(Ticket > 0) 
                  {
                  Print("Opposite Sell order placed # ", Ticket);
                  AddLimitsSell();
                  }
               else
                  {
                  Print("Order Send failed, error # ", GetLastError() );
                  }
               }
               
            if(Op == OP_SELL && (OrderClosePrice()-OrderOpenPrice()/pt)>TakeProfit)
               {               
               Ticket = OrderSend(Symbol(), OP_BUY, mlots, MartingaleBuyPrice, UseSlippage, 0, 0, "Buy Order", MagicNumber, 0, Green);
               if(Ticket > 0)
                  {
                  Print("Opposite Buy order placed # ", Ticket);
                  AddLimitsBuy();
                  }
               else
                  {  
                  Print("Order Send failed, error # ", GetLastError());
                  }   
               }
            }
         }
      }
   }
//+------------------------------------------------------------------+  
void AddLimitsBuy()
                  {
                  OrderSelect(Ticket,SELECT_BY_TICKET);
                  OpenPrice = OrderOpenPrice();
                  StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
				       RefreshRates();	
				      UpperStopLevel = Ask + StopLevel;
				      LowerStopLevel = Bid - StopLevel;
				      
				      
				      if(StopLoss > 0) BuyStopLoss   = OpenPrice - (StopLoss * pt);
                  if(TakeProfit > 0)BuyTakeProfit = OpenPrice + (TakeProfit * pt);
				      
				      if(BuyStopLoss > 0 && BuyStopLoss > LowerStopLevel) 
					      {					
						    BuyStopLoss = LowerStopLevel - MinStop*pt;
					      }
				      
				      if(BuyTakeProfit > 0 && BuyTakeProfit < UpperStopLevel) 
					      {
						     BuyTakeProfit = UpperStopLevel + MinStop*pt;
					      }

				      if(IsTradeContextBusy())Sleep(10);	

                  if(BuyStopLoss > 0 || BuyTakeProfit > 0) 
                     {		
                      OrderModify(Ticket,OP_BUY,BuyStopLoss,BuyTakeProfit,0);                            
                     }
                    } 
//+------------------------------------------------------------------+
void AddLimitsSell()
                  {
                  OrderSelect(Ticket,SELECT_BY_TICKET);                 
                  OpenPrice = OrderOpenPrice();
                  StopLevel = MarketInfo(Symbol(),MODE_STOPLEVEL)*Point;
				      RefreshRates();	
				      UpperStopLevel = Ask + StopLevel;
				      LowerStopLevel = Bid - StopLevel;
				      
				      
				      if(StopLoss > 0) SellStopLoss = OpenPrice + (StopLoss*pt);
				      if(TakeProfit > 0) SellTakeProfit = OpenPrice - (TakeProfit*pt);
				    
				      if(SellStopLoss > 0 && SellStopLoss < UpperStopLevel) 
					      {					
						    SellStopLoss = UpperStopLevel + MinStop*pt;
					      }
				      if(SellTakeProfit> 0 && SellTakeProfit > LowerStopLevel) 
					      {
						    SellTakeProfit = LowerStopLevel - MinStop*pt;
					      }
					    
				      if(IsTradeContextBusy()) Sleep(10);	

                  if(SellStopLoss > 0 || SellTakeProfit > 0) 
                    {		
                      OrderModify(Ticket,OP_SELL,SellStopLoss,SellTakeProfit,0);
                    }                    
                   }  
//+---------------------------------------------------------------------------+
    void GoToClose()
        {
         for(int pos=OrdersTotal()-1;pos>=0;pos--)
            if(OrderSelect(pos,SELECT_BY_POS)
            && OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()
            && OrderProfit()+OrderSwap()+OrderCommission()>0||OrdersTotal()>= MaxOrders)CloseAll();  
           }
//+---------------------------------------------------------------------------+
    void OpPendingDel()
    {
    int b,a;
     total = OrdersTotal();
    for (b=total-1; b >=0; b--)
      {
       OrderSelect(b,SELECT_BY_POS,MODE_TRADES);
       if(OrderSymbol()==Symbol()&& OrderMagicNumber()== MagicNumber)
       if (OrderType()==OP_BUY || OrderType()==OP_SELL)
        {
        for (a=total-1; a >=0; a--)
           {
            OrderSelect(a,SELECT_BY_POS,MODE_TRADES);
       if(OrderSymbol()==Symbol()&& OrderMagicNumber()== MagicNumber)
       if(OrderType()==OP_SELLSTOP)
              {
               OrderDelete(OrderTicket());
              }
       if(OrderType()==OP_BUYSTOP) 
         {
          OrderDelete(OrderTicket());
          }
         }
        }
       }
      }
//+---------------------------------------------------------------------------+ 
void BuyTrailingStop() 
   {   
    for(int Counter=0;Counter<=OrdersTotal()-1;Counter++)
      {
       OrderSelect(Counter,SELECT_BY_POS);
    
       MaxStopLoss = MarketInfo(Symbol(),MODE_BID)-(TrailingStop*pt);
       PipsProfit = MarketInfo(Symbol(),MODE_BID)-OrderOpenPrice();
    
        if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol() && OrderType()==OP_BUY 
          && OrderStopLoss()<MaxStopLoss && PipsProfit>=MinimumProfit*pt) 
           {
            OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);     
           }
          }
         }
//+------------------------------------------------------------------+ 
 void SellTrailingStop()
  {
   for(int Counter=0;Counter<=OrdersTotal()-1;Counter++)
      {
       OrderSelect(Counter,SELECT_BY_POS);
   
        MaxStopLoss = MarketInfo(Symbol(),MODE_ASK)+(TrailingStop*pt);
        PipsProfit = OrderOpenPrice()- MarketInfo(Symbol(),MODE_ASK);
   
        if(OrderMagicNumber()==MagicNumber && OrderSymbol()==Symbol()&& OrderType()==OP_SELL
          && OrderStopLoss()> MaxStopLoss && PipsProfit>=MinimumProfit*pt)
           {
            OrderModify(OrderTicket(),OrderOpenPrice(),MaxStopLoss,OrderTakeProfit(),0);
           }
          }
         }
//+---------------------------------------------------------------------------+

	void MoveBreakEven()
{
 int cnt,total=OrdersTotal();
 for(cnt=0;cnt<total;cnt++)
{
 OrderSelect(cnt,SELECT_BY_POS,MODE_TRADES);
 if(OrderType()<=OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)
 {
  if(OrderType()==OP_BUY)
  { 
   if(BreakEven>0)
  {
   if(NormalizeDouble((Bid-OrderOpenPrice()),Digits)>BreakEven *pt)
    {
     if(NormalizeDouble((OrderStopLoss()-OrderOpenPrice()),Digits)<0)
     {
      OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()+ProfitMin*pt,Digits),OrderTakeProfit(),0,Blue);            
      }
     }
    }
   }
   else
    {
//+------------------------------------------------------------------+   
    if(BreakEven>0)
    {
     if(NormalizeDouble((OrderOpenPrice()-Ask),Digits)>BreakEven*pt)
     { 
      if (NormalizeDouble((OrderOpenPrice()- OrderStopLoss()),Digits)<0)
      {
       OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(OrderOpenPrice()-ProfitMin*pt,Digits),OrderTakeProfit(),0,Blue);
       
       return(0);
       }
      }
     }
    }
   }
  }
 }

//+------------------------------------------------------------------+ 
      void CloseAll()
      {
        int OrdType, GLError;
   
   RefreshRates();
                    
   for(int OrderPos = OrdersTotal()-1; OrderPos >= 0; OrderPos--)
      if( OrderSelect(OrderPos, SELECT_BY_POS, MODE_TRADES)
         && OrderMagicNumber() == MagicNumber 
         && OrderSymbol() == Symbol())
         {
         OrdType = OrderType();
         if(OrdType == OP_BUY || OrdType==OP_SELL)
            {
            if(!OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), UseSlippage, Yellow))
               GLError = GetLastError();
            }

         if(OrdType == OP_SELLSTOP || OrdType == OP_BUYSTOP || OrdType == OP_BUYLIMIT || OrdType == OP_SELLLIMIT)
            {
            if(!OrderDelete(OrderTicket()))
               GLError = GetLastError();
            }

         if(GLError > 0) Print("Error Closing/Deleting Order, error # ", GLError, " for ticket: ", OrderTicket());         
         }         
      }                   
//+---------------------------------------------------------------------------+  
           
 
 

